# -*- coding: utf-8 -*-
"""
CFRAD-plot2 
Created on 21 juni 2014.
author: Michiel Klaassen; www.parac.eu
Het is niet toegestaan om dit programma te koop aan te bieden.
"""

#Algemeen
# Kopieer het script naar de directory, waar de nrad files staan.
# Start python-xy; en start dan de spyder editor.
# Kies file open; open het script, dan Run, Run (ok)
# Als de grafiek zichtbaar wordt, dan op rechtsboven X klikken om
#  het programma verder te laten lopen.
# Als men tijdens het lopen acuut wil stoppen; druk op de toetsen CTRL c.
# Als men het programma runt, dan wordt deze versie eerst ge-saved,
#  dus als men modificeert eerst saven onder een andere naam.
# In de grafiek kan men met het 5e icoontje van links inzoomen
#  in de door de muis getrokken rechthoek.
# In de grafiek icoon rechtsboven plaatje saven; duh.
#
import numpy as np
import matplotlib.pyplot as mpl
#--------settings---------------------------------------------------
filename="nrad-" 
ndp=2048; #number of data points; niet veranderen!
sr=2400.0 # sampling rate [kB/s]--- let op; geef altijd een decimaal achter de komma --
f=(sr*np.linspace(0,1,ndp))/1000 # maak een lineaire frequentie schaal [MHz]
Sf=sr/1000/2  # de helft van de schaal

#---------------------bereken band pass correction-------------------------
# selecteer een meet set, waar haast geen waterstof te vinden is.
# dit kan een struik/muur of een stille plek aan de hemel zijn
# als men dit nog niet weet kies dan om te beginnen de set 0,
# en loop het hele programma af. Als blijkt dat alle sets een negatieve 
# piek vertonen, kies dan een betere bandpass set, of nog beter een range.

vans=180 # vanaf set
ms=180 # to set; om zoveel mogelijk een gladde curve te krijgen
bpass=np.zeros((2048)) ; # begin waarde; vul met nullen 
bpcorr=np.zeros((2048)) ;
for sets in range (vans,ms+1): #
    print sets    
    datat = np.loadtxt(filename+str(sets)+".txt") 
    rbp=datat*1.00001
    for i in range (2,2046):
        if datat[i] > 1.02*datat[i-1]:# limiteren tov vorige waarde
            datat[i] = datat[i-1] #    
    rbp2=datat*1.000003        
    data=datat
    #rbp2=data*1.000003  
# symmetrisch middelen
    for i in range (2,2046):
        data[i] = (data[i-2]+data[i-1]+data[i]+data[i+1]+data[i+2])/5 #    
    for i in range (2,2046):
        data[i] = (data[i-2]+data[i-1]+data[i]+data[i+1]+data[i+2])/5 #   
    for i in range (2,2046):
        data[i] = (data[i-2]+data[i-1]+data[i]+data[i+1]+data[i+2])/5 #
    for i in range (2,2046):
        data[i] = (data[i-2]+data[i-1]+data[i]+data[i+1]+data[i+2])/5 #   
    for i in range (2,2046):
        data[i] = (data[i-2]+data[i-1]+data[i]+data[i+1]+data[i+2])/5 #
    for i in range (2,2046):
        data[i] = (data[i-2]+data[i-1]+data[i]+data[i+1]+data[i+2])/5 #   
    for i in range (2,2046):
        data[i] = (data[i-2]+data[i-1]+data[i]+data[i+1]+data[i+2])/5 #
    for i in range (4,2044):
        data[i] = (data[i-4]+data[i-3]+data[i-2]+data[i-1]+data[i]+data[i+1]+data[i+2]+data[i+3]+data[i+4])/9 #  
    for i in range (4,2044):
        data[i] = (data[i-4]+data[i-3]+data[i-2]+data[i-1]+data[i]+data[i+1]+data[i+2]+data[i+3]+data[i+4])/9 #  
    for i in range (4,2044):
        data[i] = (data[i-4]+data[i-3]+data[i-2]+data[i-1]+data[i]+data[i+1]+data[i+2]+data[i+3]+data[i+4])/9 #  
        
    bpass=bpass+data # sommeer
bpass=bpass/( ms+1-vans)# bepaal het gemiddelde van de range
bpcorr=1/(bpass) # 


fig=mpl.figure(1)
ax = fig.add_subplot(111)
ax.plot(f-Sf,rbp,linewidth=1,label='$raw bp$')
ax.plot(f-Sf,bpass,linewidth=3,label='$Band pass$')
ax.plot(f-Sf,rbp2,linewidth=1,label='$no peak$')
ax.plot(f-Sf,bpcorr,label='$bpcorr.$')
ax.legend(loc=0)
ax.set_xlim( -Sf, Sf)
ax.set_ylim( 0,20) 
ax.set_title('Band Pass & Correction factor')
ax.set_xlabel('Frequency +1420 [MHz]')
ax.set_ylabel('unity')
mpl.show()

#------------------------selected set-----------------
# select een set om de goede werking van de bandpass correctie 
#   en limiteer functies te zien
sets=29 # select een set van 0 tot 288

raw1=np.zeros((2048));
raw2=np.zeros((2048));
raw3=np.zeros((2048));
ata=np.zeros((2048));
dat=np.zeros((2048));
dataset = np.loadtxt(filename+str(sets)+".txt") 
raw1 = dataset*bpcorr #de bandpass correctie uitvoeren (controle file voor spikes)
ata=dataset*bpcorr #de bandpass correctie uitvoeren

for i in range (2,2046):
    if ata[i] > 1.1: # 1.3 limiteer absolute waarde
        ata[i] = ata[i-1] #
# begrens alles boven 'bepaald' gemiddelde zelf experimenteren om RFI spikes te onderdrukken
gem=np.mean(ata,0)
for i in range (2,2046):
        if ata[i] > 1.1*gem:#1.02:#
            ata[i] = 1.3*gem #
#begrens  tov vorige waarde; een te snelle rise tijd bestaat niet; zelf experimenteren
for i in range (2,2046):
        if ata[i] > 1.1*ata[i-1]:#
            ata[i] = ata[i-1] #
dat=ata#*1.001
raw2=dat*1.00002  

#hier kunnen andere routines komen voor bv selectie van de laagste waardes of de hoogste waardes

          
#print raw3
data=dat*1.00001
for i in range (2,2046):
    data[i] = (data[i-2]+data[i-1]+data[i]+data[i+1]+data[i+2])/5  #
    data[i] = (data[i-2]+data[i-1]+data[i]+data[i+1]+data[i+2])/5  #
    data[i] = (data[i-2]+data[i-1]+data[i]+data[i+1]+data[i+2])/5  #
raw3=data*1.000001 # als op meerdere plaatsen dezelfde variable gebruikt wordt 
# (omdat copy en paste voor de programmeur zo makkelijk is) 
# dan kan hierdoor voor het programma verwarring ontstaan 
# daarom wordt een tussen variable met een minieme afwijking gekreeerd

for i in range (4,2044):
    data[i] = (data[i-4]+data[i-3]+data[i-2]+data[i-1]+data[i]+data[i+1]+data[i+2]+data[i+3]+data[i+4])/9 #  
for i in range (4,2044):
    data[i] = (data[i-4]+data[i-3]+data[i-2]+data[i-1]+data[i]+data[i+1]+data[i+2]+data[i+3]+data[i+4])/9 #  
for i in range (4,2044):
    data[i] = (data[i-4]+data[i-3]+data[i-2]+data[i-1]+data[i]+data[i+1]+data[i+2]+data[i+3]+data[i+4])/9 #  
raw4=data*1.00001        



        
fig=mpl.figure(sets)
ax = fig.add_subplot(111)
ax.plot(f-Sf,raw1, linewidth=1,label='$raw1$')
ax.plot(f-Sf,raw2, linewidth=1,label='$raw2$')
ax.plot(f-Sf,raw3, linewidth=1,label='$raw3$')
ax.plot(f-Sf,raw4, linewidth=1,label='$raw4$')
ax.legend(loc=0)
ax.set_xlim( -Sf, Sf)
ax.set_ylim( 0.8,1.2) 
ax.set_title('Selected')
ax.set_xlabel('Frequency +1420 [MHz]') #zelf de 1420 aanpassen als een andere frequentie op sharp# was ingesteld
ax.set_ylabel('Vrms')
mpl.show()


#--------------series-------------------------------------------------------------
vans=29 # bereken de 5 minuten sets vanaf set x 
ms=29 # tot set xx
offcor=np.zeros((ms+1,1));
rawsets=np.zeros((ms+1,2048));
offsets=np.zeros((ms+1,1)) ;
outsets=np.zeros((ms+1,2048)) ; 
sumsets=np.zeros((ms+1,2048)) ; 

for sets in range (vans,ms+1): #ms+1):
    print sets    
    data = np.loadtxt(filename+str(sets)+".txt") 
    data=data*bpcorr 
    
    for i in range (2,2046):
        if data[i] > 1.1: # 1.3 limiteer absoluut
            data[i] = data[i-1] #

    gem=np.mean(data,0)
    for i in range (2,2046):
        if data[i] > 1.3*gem:# 1.02 limiteer afhankelijk van gemiddelde
            data[i] = 1.3*gem #

    for i in range (2,2046):
        if data[i] > 1.1*data[i-1]: # limiteer tov vorige waarde
            data[i] = data[i-1] #   

    for i in range (2,2046):
        data[i] = (data[i-1]+data[i]+data[i+1])/3 #
    for i in range (2,2046):
        data[i] = (data[i-2]+data[i-1]+data[i]+data[i+1]+data[i+2])/5 #      
    for i in range (2,2046):
        data[i] = (data[i-2]+data[i-1]+data[i]+data[i+1]+data[i+2])/5 #

    outsets[sets] = (data)
  
    offsets[sets]=(sets*0.01)#+0.05 #4


#---------------------plot series----
fig=mpl.figure(2)
ax = fig.add_subplot(111)
ax.plot(f-Sf,(raw1),linewidth=2) # deze set erbij om de spikes te zien
for i in range (vans,ms+1):
    ax.plot(f-Sf,(outsets[i]+offsets[i]+0.1))
    if i==180:
        ax.plot(f-Sf,((outsets[i])+offsets[i]+0.1),linewidth=2)
    if i==190:
        ax.plot(f-Sf,((outsets[i])+offsets[i]+0.1),linewidth=2)


ax.set_xlim( -Sf, Sf)
ax.set_ylim(0.8,4.2)  
ax.set_title('mw')
ax.set_xlabel('Frequency +1420 [MHz]')
ax.set_ylabel('W')
mpl.show()


exit()
